#include "global.h"
#include "4inarow.h"
#include "netstuff.h"

int main(int argc, char *argv[]) 
{
  struct sockaddr_in gameserver;
  struct hostent *host;
  char tmp[10],buffer[BSIZE],color1=YELLOW,color2=RED,player[MAXC];
  int tcpsock,gameserver_len,move1,move2;
  fourinarow *four_game;
  if(argc<2)
  {
    printf("\nSyntax: 4inarow host\n");
    exit(0);
  }
  host=gethostbyname(argv[1]);
  if (host==NULL)
  {
    perror("\n4inarow: unknown host");
    printf("\n");
    exit(-1);
  }
  tcpsock=socket(AF_INET,SOCK_STREAM,0);
  if(tcpsock<0)
  {
    perror("\n4inarow: socket error");
    printf("\n");
    exit(-1);
  }
  gameserver.sin_family=host->h_addrtype;
  memcpy(&gameserver.sin_addr.s_addr,host->h_addr,host->h_length);
  gameserver.sin_port=htons(SPORT1);
  gameserver_len=sizeof gameserver;
  if(connect(tcpsock,(struct sockaddr *)&gameserver,gameserver_len)<0) 
  {
    perror("\n4inarow: connect error");
    printf("\n");
    exit(-1);
  }
  four_game=(fourinarow *)malloc(sizeof(fourinarow));
  strcpy(player,"player2");
  initialize(four_game);
  print_game(four_game);
  while(1)
  {
    read_socket(tcpsock,buffer);
    sscanf(buffer,"%s",tmp);
    if(strcmp(tmp,"begin")==0)
    {
      color1=RED;
      color2=YELLOW;
      strcpy(player,"player1");
    } 
    else if(strcmp(tmp,"insert")==0)
    {
      sscanf(buffer,"%*s %d",&move2);
      insert(four_game,move2,color2);
      print_game(four_game);
      printf("\nlast opponent move: %d",move2+1);
      if(checking(four_game,move2,color2)==TRUE)
      {
        printf("\nYOU LOOSE!!!\n");
        sprintf(buffer,"%s","endgame");
        write_socket(tcpsock,buffer);
        exit(0);
      }
    }
    if(four_game->nmoves<NMOVES)
    {
      move1=insert_column(four_game,player);
      insert(four_game,move1,color1);
      print_game(four_game);
      sprintf(buffer,"%s %d","move",move1);
      write_socket(tcpsock,buffer);
      if(checking(four_game,move1,color1)==TRUE)
      {
        printf("\nYOU WIN!!!\n");
        exit(0);
      }
    }
    else
    {
      printf("\nDRAW GAME\n");
      sprintf(buffer,"%s","endgame");
      if(strcmp(player,"player1")==0) write_socket(tcpsock,buffer);
      exit(0);
    }
  }
}
