#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>

#include "global.h"
#include "4inarow.h"
#include "netstuff.h"

void wait_exit_status()
{
  wait(0);
  signal(SIGCHLD,wait_exit_status);
}

void play_4inarow(int p1,int p2)
{
  char buffer[BSIZE],tmp[10];
  int player_descriptors[2],turn,end_game,move;
  player_descriptors[0]=p1;
  player_descriptors[1]=p2;
  turn=0;
  end_game=0;
  strcpy(buffer,"begin");
  write_socket(player_descriptors[turn],buffer);
  while(end_game==0)
  {
    read_socket(player_descriptors[turn],buffer);
    sscanf(buffer,"%s %d",tmp,&move);
    if(strcmp(tmp,"endgame")==0) end_game=1;
    else if(strcmp(tmp,"move")==0)
    {
      sprintf(buffer,"%s %d","insert",move);
      write_socket(player_descriptors[1-turn],buffer);
    }
    else
    {
      perror("\n4rowserver: protocol error");
      printf("\n");
      exit(-1);
    }
    turn=1-turn;
  }
}      
  
int main(void) 
{
  struct sockaddr_in client,client1, gameserver;
  int client_len,client1_len,tcpsock,descr,descr1;
  signal(SIGCHLD,wait_exit_status);
  tcpsock = socket(AF_INET,SOCK_STREAM,0);
  if (tcpsock<0)
  {
    perror("\n4rowserver: socket error");
    printf("\n");
    exit(-1);
  }
  gameserver.sin_family = AF_INET;
  gameserver.sin_addr.s_addr = htonl(INADDR_ANY);
  gameserver.sin_port = htons(SPORT1);
  if (bind(tcpsock,(struct sockaddr*)&gameserver,sizeof(gameserver))<0)
  {
    perror("\n4rowserver: bind failed");
    printf("\n");
    exit(-1);
  }
  if(listen(tcpsock,4)==-1)
  {
    perror("\n4rowserver: listen failed");
    printf("\n");
    exit(6);
  }
  while(1)
  {
    client_len=sizeof(client);
    client1_len=sizeof(client1);
    while((descr=accept(tcpsock,(struct sockaddr *)&client,&client_len))<0)
    {
      if(errno!=EINTR)
      {
        perror("\n4rowserver: accepting connection");
        printf("\n");
        exit(-1);
      }
    }
    while((descr1=accept(tcpsock,(struct sockaddr *)&client1,&client1_len))<0)
    {
      if(errno!=EINTR)
      {
        perror("\n4rowserver: accepting connection");
        printf("\n");
        exit(-1);
      }
    }
    if(fork()==0)
    {
      close(tcpsock);
      play_4inarow(descr,descr1);
      exit(0);
    }
    else
    {
      close(descr);
      close(descr1);
    }
  }
}
